> ## Documentation Index
> Fetch the complete documentation index at: https://docs.toku.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Expense Audit Trail

> Lists audit entries for an expense report with actor names, for owner or scoped reviewer.

Not available to API keys.

## OpenAPI

````yaml api-reference/openapi.json GET /hris/get-expense-audit-trail
openapi: 3.1.0
info:
  title: Toku API
  version: 1.0.0
servers:
  - url: https://api.toku.com
security:
  - bearerAuth: []
paths:
  /hris/get-expense-audit-trail:
    get:
      operationId: getExpenseAuditTrail
      summary: Get Expense Audit Trail
      description: >-
        Lists audit entries for an expense report with actor names, for owner or
        scoped reviewer.


        Not available to API keys.
      parameters:
        - name: hrisExpenseReportID
          in: query
          required: true
          schema:
            type: string
            format: uuid
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetExpenseAuditTrailResponse'
        '400':
          description: Bad request
        '401':
          description: Unauthorized
        '403':
          description: Forbidden
        '404':
          description: Not found
        '409':
          description: Conflict
        '429':
          description: Response 429
components:
  schemas:
    GetExpenseAuditTrailResponse:
      type: array
      items:
        oneOf:
          - oneOf:
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    type: string
                    enum:
                      - CREATED
                      - SUBMITTED
                      - CANCELLED
                  beforeState:
                    type:
                      - object
                      - 'null'
                    properties:
                      status:
                        type: string
                        enum:
                          - DRAFT
                          - SUBMITTED
                          - PENDING_INFO
                          - APPROVED
                          - REJECTED
                          - CANCELLED
                    required:
                      - status
                  afterState:
                    type:
                      - object
                      - 'null'
                    properties:
                      status:
                        type: string
                        enum:
                          - DRAFT
                          - SUBMITTED
                          - PENDING_INFO
                          - APPROVED
                          - REJECTED
                          - CANCELLED
                    required:
                      - status
                  metadata:
                    type:
                      - 'null'
                      - 'null'
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: APPROVED
                  beforeState:
                    type: object
                    properties:
                      status:
                        type: string
                        enum:
                          - DRAFT
                          - SUBMITTED
                          - PENDING_INFO
                          - APPROVED
                          - REJECTED
                          - CANCELLED
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      status:
                        const: APPROVED
                    required:
                      - status
                  metadata:
                    type:
                      - 'null'
                      - 'null'
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: REJECTED
                  beforeState:
                    type: object
                    properties:
                      status:
                        type: string
                        enum:
                          - DRAFT
                          - SUBMITTED
                          - PENDING_INFO
                          - APPROVED
                          - REJECTED
                          - CANCELLED
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      status:
                        const: REJECTED
                    required:
                      - status
                  metadata:
                    type: object
                    properties:
                      rejectionReason:
                        type: string
                    required:
                      - rejectionReason
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: INFO_REQUESTED
                  beforeState:
                    type: object
                    properties:
                      status:
                        const: SUBMITTED
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      status:
                        const: PENDING_INFO
                    required:
                      - status
                  metadata:
                    type: object
                    properties:
                      comment:
                        type: string
                    required:
                      - comment
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: RESUBMITTED
                  beforeState:
                    type: object
                    properties:
                      status:
                        const: PENDING_INFO
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      status:
                        const: SUBMITTED
                    required:
                      - status
                  metadata:
                    type: object
                    properties:
                      comment:
                        type: string
                    required:
                      - comment
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: LINE_ITEM_FLAGGED
                  beforeState:
                    type:
                      - 'null'
                      - 'null'
                  afterState:
                    type:
                      - 'null'
                      - 'null'
                  metadata:
                    type: object
                    properties:
                      flagReason:
                        type: string
                    required:
                      - flagReason
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: PROCESSING_STARTED
                  beforeState:
                    type: object
                    properties:
                      status:
                        const: APPROVED
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      payoutStatus:
                        const: PROCESSING
                    required:
                      - payoutStatus
                  metadata:
                    type:
                      - 'null'
                      - 'null'
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: PAID
                  beforeState:
                    type: object
                    properties:
                      status:
                        type: string
                        enum:
                          - DRAFT
                          - SUBMITTED
                          - PENDING_INFO
                          - APPROVED
                          - REJECTED
                          - CANCELLED
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      payoutStatus:
                        const: PAID
                    required:
                      - payoutStatus
                  metadata:
                    type:
                      - object
                      - 'null'
                    properties:
                      paymentRecordID:
                        type: string
                        format: uuid
                      proofReference:
                        type:
                          - string
                          - 'null'
                    required:
                      - paymentRecordID
                      - proofReference
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: DECISION_UNDONE
                  beforeState:
                    type: object
                    properties:
                      status:
                        type: string
                        enum:
                          - APPROVED
                          - REJECTED
                      approvedAt:
                        type:
                          - string
                          - 'null'
                      rejectedAt:
                        type:
                          - string
                          - 'null'
                      rejectionReason:
                        type:
                          - string
                          - 'null'
                      reviewComment:
                        type:
                          - string
                          - 'null'
                    required:
                      - status
                      - approvedAt
                      - rejectedAt
                      - rejectionReason
                      - reviewComment
                  afterState:
                    type: object
                    properties:
                      status:
                        const: SUBMITTED
                    required:
                      - status
                  metadata:
                    type: object
                    properties:
                      reason:
                        type: string
                      undoneDecisionAt:
                        type: string
                      approvalSteps:
                        type: array
                        items:
                          type: object
                          properties:
                            hrisExpenseReportApprovalStepID:
                              type: string
                              format: uuid
                            stepOrder:
                              type: integer
                            status:
                              type: string
                              enum:
                                - APPROVED
                                - REJECTED
                            actedAt:
                              type:
                                - string
                                - 'null'
                            actedByRoleInOrgID:
                              type:
                                - string
                                - 'null'
                              format: uuid
                            comment:
                              type:
                                - string
                                - 'null'
                          required:
                            - hrisExpenseReportApprovalStepID
                            - stepOrder
                            - status
                            - actedAt
                            - actedByRoleInOrgID
                            - comment
                      expenses:
                        type: array
                        items:
                          type: object
                          properties:
                            hrisExpenseID:
                              type: string
                              format: uuid
                            status:
                              type: string
                              enum:
                                - APPROVED
                                - REJECTED
                            rejectionReason:
                              type:
                                - string
                                - 'null'
                          required:
                            - hrisExpenseID
                            - status
                            - rejectionReason
                    required:
                      - reason
                      - undoneDecisionAt
                      - approvalSteps
                      - expenses
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: IMPORTED_FROM_CSV
                  beforeState:
                    type:
                      - 'null'
                      - 'null'
                  afterState:
                    type: object
                    properties:
                      status:
                        const: DRAFT
                    required:
                      - status
                  metadata:
                    type: object
                    properties:
                      fileName:
                        type:
                          - string
                          - 'null'
                      uploadID:
                        type: string
                      rows:
                        type: array
                        items:
                          type: integer
                          minimum: 0
                    required:
                      - fileName
                      - uploadID
                      - rows
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: IMPORTED_FROM_CSV_LINE
                  beforeState:
                    type:
                      - 'null'
                      - 'null'
                  afterState:
                    type:
                      - 'null'
                      - 'null'
                  metadata:
                    type: object
                    properties:
                      sourceKey:
                        type: string
                      baseKey:
                        type: string
                      uploadID:
                        type: string
                      fileFingerprint:
                        type: string
                      fileName:
                        type:
                          - string
                          - 'null'
                      rowId:
                        type: integer
                        minimum: 0
                      confirmedDuplicate:
                        type: boolean
                      addedAgain:
                        type: boolean
                    required:
                      - sourceKey
                      - baseKey
                      - uploadID
                      - fileFingerprint
                      - fileName
                      - rowId
                      - confirmedDuplicate
                      - addedAgain
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
            discriminator:
              propertyName: action
          - oneOf:
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: PROCESSING_STARTED
                  beforeState:
                    type: object
                    properties:
                      status:
                        const: APPROVED
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      status:
                        const: PROCESSING
                    required:
                      - status
                  metadata:
                    type:
                      - 'null'
                      - 'null'
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
              - type: object
                properties:
                  auditID:
                    type: string
                    format: uuid
                  actorRoleInOrgID:
                    type: string
                    format: uuid
                  actorName:
                    type: string
                  createdAt:
                    type: string
                  action:
                    const: PAID
                  beforeState:
                    type: object
                    properties:
                      status:
                        type: string
                        enum:
                          - APPROVED
                          - PROCESSING
                    required:
                      - status
                  afterState:
                    type: object
                    properties:
                      status:
                        const: PAID
                    required:
                      - status
                  metadata:
                    type:
                      - 'null'
                      - 'null'
                required:
                  - auditID
                  - actorRoleInOrgID
                  - actorName
                  - createdAt
                  - action
                  - beforeState
                  - afterState
                  - metadata
            discriminator:
              propertyName: action
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
````
